C vel=munfold(v)
      subroutine mexfunction(nlhs, plhs, nrhs, prhs)

      integer*4 nlhs, nrhs
      integer*4 plhs(*), prhs(*)

      integer*4 m_in, n_in
      integer*4 vp, velp

      m_in = mxgetm(prhs(1))
      n_in = mxgetn(prhs(1))
      
      vp = mxgetpr(prhs(1))

      plhs(1) = mxcreatefull(m_in, n_in, 0)
      
      velp = mxgetpr(plhs(1))

      call munfold(%VAL(velp), %VAL(vp), m_in, n_in)

      return
      end

C================main munfold subroutine=========================
      
      subroutine munfold(vel, v, mm, nn)
      IMPLICIT NONE
      integer*4 mm, nn, M, N
      integer*4 i, j

      PARAMETER (M=400, N=1600)
      real*8 vel(mm, nn), v(mm, nn)
      real*8 maxvar, lonely1

      real*8 vz(M,N), nan, off, diff
      real*8 v0(N), v1(N), means(N), m2(N), mom, 
     :       total, num, momtot,momnum, vf
      real*8 mask(M,N)
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

      IF ((mm.LE.M).AND.(nn.LE.N)) THEN
         
         maxvar=4.0
         lonely1=3.0
         vf=30
         
         CALL mzap(vel,v,maxvar,lonely1,0.0,mm,nn)

         DO j=1,nn
            v0(j)=0
         ENDDO

         DO i=1,mm
            DO j=1,nn
               v1(j)=vel(i,j)
               IF (v1(j).LT.(v0(j)-45)) THEN
                  v1(j)=v1(j)+60
               ELSEIF (v1(j).LT.(v0(j)-15)) THEN
                  v1(j)=v1(j)+30
               ELSEIF (v1(j).LT.(v0(j)+15)) THEN
                  v1(j)=v1(j)+0
               ELSEIF (v1(j).LT.(v0(j)+45)) THEN
                  v1(j)=v1(j)-30
               ELSE
                  v1(j)=v1(j)-60
               ENDIF
               
               vz(i,j)=v1(j)    !can use vz variable later (rather 
                                !than vzn)

               IF (mexIsNaN(v1(j)).EQ.1) THEN
                  v1(j)=v0(j)
               ENDIF

               mask(i,j)=v1(j)

               v0(j)=v1(j)
               
            ENDDO

         ENDDO

C     Work out means, and the mean of means
         momtot=0
         momnum=0
         DO j=1,nn
            total=0
            num=0
            DO i=1,mm
               IF (mexIsNaN(vz(i,j)).EQ.0) THEN
                  total=total+vz(i,j)
                  num=num+1
               ENDIF
            ENDDO
            IF (num.GT.0) THEN
               means(j)=total/num
            ELSE 
               means(j)=nan
            ENDIF
            IF (mexIsNaN(means(j)).EQ.0) THEN
               momtot=momtot+means(j)
               momnum=momnum+1
            ENDIF
         ENDDO

C     mom=mean of means
         mom=momtot/momnum

         DO j=1,nn
            IF (mexIsNaN(means(j)).EQ.1) THEN
               means(j)=mom
            ENDIF
            m2(j)=means(j)
         ENDDO

C     use continuity in the means (neglecting NaNs) to adjust the
c     result

         DO j=2,nn
            IF (j.EQ.2) THEN
               diff=means(j)-m2(j-1)
            ELSE
               diff=means(j)-(m2(j-1)+m2(j-2))/2.0
            ENDIF
            IF (diff.GT.45) THEN
               off=60
            ELSEIF (diff.GT.15) THEN
               off=30
            ELSEIF (diff.GT.-15) THEN
               off=0
            ELSEIF (diff.GT.-45) THEN
               off=-30
            ELSE
               off=-60
            ENDIF
            DO i=1,mm
               vz(i,j)=off
            ENDDO
            m2(j)=means(j)-off
         ENDDO

         DO i=1,mm
            vz(i,1)=off
         ENDDO

         DO i=1,mm
            DO j=1,nn
               mask(i,j)=mask(i,j)-vz(i,j)
C     Unfold v into vel using offset (variable vz)
               IF (v(i,j).LT.(mask(i,j)-45)) THEN
                  vel(i,j)=v(i,j)+60
               ELSEIF (v(i,j).LT.(mask(i,j)-15)) THEN
                  vel(i,j)=v(i,j)+30
               ELSEIF (v(i,j).LT.(mask(i,j)+15)) THEN
                  vel(i,j)=v(i,j)+0
               ELSEIF (v(i,j).LT.(mask(i,j)+45)) THEN
                  vel(i,j)=v(i,j)-30
               ELSE
                  vel(i,j)=v(i,j)-60
               ENDIF

            ENDDO
         ENDDO

      ELSE                      !mm and/or nn too big

         PRINT*, "input matrix is too large. mm, nn="
         PRINT*, mm,nn
         PRINT*, "M, N="
         PRINT*, M,N
         DO i=1,mm
            DO j=1,nn
               vel(i,j)=v(i,j)
            ENDDO
         ENDDO
         
      ENDIF

      return
      end

C=============================================================
C================main mzap subroutine=========================
C=============================================================
C Note vel has fixed dimensions - M,N have to be same as above
      
      subroutine mzap(vel, v, maxvar, lonely1, lonely2, mm, nn)
      IMPLICIT NONE
      integer*4 mm, nn, M, N
      integer*4 i, j, k

      PARAMETER (M=400, N=1600)
      real*8 maxvar, lonely1, lonely2
      real*8 vel(mm,nn), v(mm, nn)

      real*8 mv2, var(M,N), nan
      integer mask1(M,N)
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

      mv2=maxvar**2.0

C work out the variance matrix

      DO i=2,mm-1
         DO j=2,nn-1
            var(i,j)=(((v(i,j-1)-v(i,j))**2)+((v(i,j-1)-v(i,j))**2)+
     :((v(i+1,j-1)-v(i,j))**2)+((v(i-1,j)-v(i,j))**2)+((v(i+1,j)-
     :v(i,j))**2)+((v(i-1,j+1)-v(i,j))**2)+((v(i,j+1)-v(i,j))**2)+
     :((v(i+1,j-1)-v(i,j))**2))/8.0
         ENDDO
      ENDDO
      
      DO i=2,mm-1 
         var(i,nn)=(((v(i-1,nn)-v(i,nn))**2)+((v(i-1,nn-1)-
     :v(i,nn))**2)+((v(i,nn-1)-v(i,nn))**2)+((v(i+1,nn-1)-
     :v(i,nn))**2)+((v(i+1,nn)-v(i,nn))**2))/5.0

         var(i,1)=(((v(i-1,1)-v(i,1))**2)+((v(i-1,2)-v(i,1))**2)+
     :    ((v(i,2)-v(i,1))**2)+((v(i+1,2)-v(i,1))**2)+((v(i+1,1)-
     :    v(i,1))**2))/5.0
      ENDDO

      DO j=2,nn-1 
         var(1,j)=(((v(1,j-1)-v(1,j))**2)+((v(2,j-1)-v(1,j))**2)+
     :    ((v(2,j)-v(1,j))**2)+((v(2,j+1)-v(1,j))**2)+((v(1,j+1)-
     :    v(1,j))**2))/5.0

         var(mm,j)=(((v(mm,j-1)-v(mm,j))**2)+((v(mm-1,j-1)-
     :    v(mm,j))**2)+((v(mm-1,j)-v(mm,j))**2)+((v(mm-1,j+1)-
     :    v(mm,j))**2)+((v(mm,j+1)-v(mm,j))**2))/5.0
      ENDDO
    
C now do the corners - what a pain
      var(1,1)=(((v(2,1)-v(1,1))**2)+((v(1,2)-v(1,1))**2)+
     :((v(2,2)-v(1,1))**2))/3.0
      var(mm,1)=(((v(mm-1,1)-v(mm,1))**2)+((v(1,2)-v(mm,1))**2)+
     :((v(mm-1,2)-v(mm,1))**2))/3.0
      var(1,nn)=(((v(2,nn)-v(1,nn))**2)+((v(1,nn-1)-v(1,nn))**2)+
     :((v(2,nn-1)-v(1,nn))**2))/3.0
      var(mm,nn)=(((v(mm-1,nn)-v(mm,nn))**2)+((v(mm,nn-1)-
     :v(mm,nn))**2)+((v(mm-1,nn-1)-v(mm,nn))**2))/3.0

C create the mask, and prepare v, vel for rotated calc
      
      DO i=1,mm
         DO j=1,nn
            IF (var(i,j).LT.mv2) THEN
               mask1(i,j)=1
            ELSE
               mask1(i,j)=0
            ENDIF
            vel(i,j)=v(i,j)+15.0
            IF (vel(i,j).GT.15) THEN
               vel(i,j)=vel(i,j)-30
            ENDIF
         ENDDO
      ENDDO

C work out the variance matrix for the rotated v

      DO i=2,mm-1
         DO j=2,nn-1
            var(i,j)=(((vel(i,j-1)-vel(i,j))**2)+((vel(i,j-1)-vel(i,j)
     $           )**2)+((vel(i+1,j-1)-vel(i,j))**2)+((vel(i-1,j)-vel(i
     $           ,j))**2)+((vel(i+1,j)-vel(i,j))**2)+((vel(i-1,j+1)
     $           -vel(i,j))**2)+((vel(i,j+1)-vel(i,j))**2)+((vel(i+1,j
     $           -1)-vel(i,j))**2))/8.0
         ENDDO
      ENDDO
      
      DO i=2,mm-1 
         var(i,nn)=(((vel(i-1,nn)-vel(i,nn))**2)+((vel(i-1,nn-1)-
     :vel(i,nn))**2)+((vel(i,nn-1)-vel(i,nn))**2)+((vel(i+1,nn-1)-
     :vel(i,nn))**2)+((vel(i+1,nn)-vel(i,nn))**2))/5.0

         var(i,1)=(((vel(i-1,1)-vel(i,1))**2)+((vel(i-1,2)-vel(i,1))
     $        **2)+((vel(i,2)-vel(i,1))**2)+ ((vel(i+1,2)-vel(i,1))**2
     $        )+((vel(i+1,1)-vel(i,1))**2))/5.0
      ENDDO

      DO j=2,nn-1 
         var(1,j)=(((vel(1,j-1)-vel(1,j))**2)+ 
     :        ((vel(2,j-1)-vel(1,j))**2)+
     :        ((vel(2,j)-vel(1,j))**2)+((vel(2,j+1)-vel(1,j))**2)
     :        +((vel(1,j+1)-vel(1,j))**2))/5.0

         var(mm,j)=(((vel(mm,j-1)-vel(mm,j))**2)+((vel(mm-1,j-1)-
     :    vel(mm,j))**2)+((vel(mm-1,j)-vel(mm,j))**2)+((vel(mm-1,j+1)-
     :    vel(mm,j))**2)+((vel(mm,j+1)-vel(mm,j))**2))/5.0
      ENDDO
   
C now do the corners - what a pain
      var(1,1)=(((vel(2,1)-vel(1,1))**2)+((vel(1,2)-vel(1,1))**2)+
     :((vel(2,2)-vel(1,1))**2))/3.0
      var(mm,1)=(((vel(mm-1,1)-vel(mm,1))**2)
     : +((vel(1,2)-vel(mm,1))**2)+((vel(mm-1,2)-vel(mm,1))**2))/3.0
      var(1,nn)=(((vel(2,nn)-vel(1,nn))**2)+ 
     :((vel(1,nn-1)-vel(1,nn))**2)+((vel(2,nn-1)-vel(1,nn))**2))/3.0
      var(mm,nn)=(((vel(mm-1,nn)-vel(mm,nn))**2)+((vel(mm,nn-1)-
     :vel(mm,nn))**2)+((vel(mm-1,nn-1)-vel(mm,nn))**2))/3.0

C create the second mask, and create composite, requiring
C discontinuity in both velocity fields
      
      DO i=1,mm
         DO j=1,nn
            vel(i,j)=nan
            IF ((var(i,j).LT.mv2).OR.(mask1(i,j).EQ.1)) THEN
               vel(i,j)=v(i,j)
            ENDIF
         ENDDO
      ENDDO

C check for lonely points in data sparse regions
      DO i=2,mm-1
         DO j=2,nn-1
            mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN
     :(vel(i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))+
     :mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))+mexIsNaN(vel(
     :i+1,j-1))+mexIsNaN(vel(i,j-1))+mexIsNaN(vel(i-1,j-1)))
     :.GT.lonely1))
         ENDDO
      ENDDO

      i=1
      k=mm
      DO j=2,nn-1
         mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN(vel
     :(i,j+1))+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))+mexIsNaN
     :(vel(i+1,j-1))+mexIsNaN(vel(i,j-1))).GT.(lonely1*5/8)))
         mask1(k,j)=((mexIsNaN(vel(k,j)).EQ.0).AND.((mexIsNaN(vel
     :(k-1,j))+mexIsNaN(vel(k-1,j+1))+mexIsNaN(vel(k,j+1))+mexIsNaN
     :(vel(k,j-1))+mexIsNaN(vel(k-1,j-1))).GT.(lonely1*5/8)))
      ENDDO

      j=1
      k=nn
      DO i=2,mm-1
         mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN(vel
     :(i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))+mexIsNaN
     :(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))).GT.(lonely1*5/8)))
         mask1(i,k)=((mexIsNaN(vel(i,k)).EQ.0).AND.((mexIsNaN(vel
     :(i-1,k))+mexIsNaN(vel(i+1,k))+mexIsNaN(vel(i+1,k-1))+mexIsNaN
     :(vel(i,k-1))+mexIsNaN(vel(i-1,k-1))).GT.(lonely1*5/8)))
      ENDDO

      DO i=1,mm
         DO j=1,nn
            IF (mask1(i,j).EQ.1) THEN
               vel(i,j)=nan
            ENDIF
         ENDDO
      ENDDO

      DO i=2,mm-1
         DO j=2,nn-1
            mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel
     :(i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))+mexIsNaN
     :(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))+mexIsNaN(vel(i+1,j-1))+
     :mexIsNaN(vel(i,j-1))+mexIsNaN(vel(i-1,j-1))).LT.lonely2))
         ENDDO
      ENDDO

      i=1
      k=mm
      DO j=2,nn-1
         mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel(i,j+1))
     :+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))+mexIsNaN(vel
     :(i+1,j-1))+mexIsNaN(vel(i,j-1))).LT.(lonely2*5/8)))
         mask1(k,j)=((mexIsNaN(vel(k,j))).AND.((mexIsNaN(vel(k-1,j))
     :+mexIsNaN(vel(k-1,j+1))+mexIsNaN(vel(k,j+1))+mexIsNaN(vel
     :(k,j-1))+mexIsNaN(vel(k-1,j-1))).LT.(lonely2*5/8)))
      ENDDO

      k=nn
      j=1
      DO i=2,mm-1
         mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel(i-1,j))
     :+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))+mexIsNaN(vel
     :(i+1,j+1))+mexIsNaN(vel(i+1,j))).LT.(lonely2*5/8)))
         mask1(i,k)=((mexIsNaN(vel(i,k))).AND.((mexIsNaN(vel(i-1,k))
     :+mexIsNaN(vel(i+1,k))+mexIsNaN(vel(i+1,k-1))+mexIsNaN(vel
     :(i,k-1))+mexIsNaN(vel(i-1,k-1))).LT.(lonely2*5/8)))
      ENDDO

      DO i=1,mm
         DO j=1,nn
            IF (mask1(i,j).EQ.1) THEN
               vel(i,j)=nan
            ENDIF
         ENDDO
      ENDDO


      return
      end
      
