%clear;

dIQ=4/5; %IQ quantisation relative to 1/4 dB (use dIQ=4/3 for 94 GHz as quantisation is 1/3 dB)

load dump.mat

[n m] = size(dump);

if floor(log(n-4)./log(2)) ~= log(n-4)./log(2)
   warning(['Did you really mean to use ' num2str(n-4) ' points?'])
end

% dump=reshape(dump,m,n).'; % this corrects for old -> new matlab format prob.

    rangei = 1:3:(m-2);
    gates = (m-2)/3;

%   date = dump(2,[1 2 3]);
%   time = dump(3,[1 2 3]);
%   pos =  dump(4,[1 2]);
%   day = date(1);mon=date(2);yr =date(3);
%   hr =  time(1);minute=time(2);sec=time(3);
%   az =   pos(1);el = pos(2);

    seq_start = 5;
    hi = (seq_start):2:n;           % horizontal I phase
    vi = (seq_start+1):2:n;         % vertical   I phase
    ui = (seq_start):n;     % unpolarised I phase
    clear seq_start

    lini = (1+2):3:m;
% May need to swap phasei and phaseq around...
    phasei = (2+2):3:m;
    phaseq = (3+2):3:m;
    range = dump(1,rangei);
    rangein = dump(1,rangei+1);

    zlin_h = dump(hi,lini).^dIQ;
    zlin_v = dump(vi,lini).^dIQ;
   zlin_u = dump(ui,lini).^dIQ;
   zlin_o=dump(ui,lini);
   zmean = mean(zlin_u);
%   I=dump(ui,phasei);
%   Q=dump(ui,phaseq);

   zphase_u = (dump(ui,phasei)+j*dump(ui,phaseq))-ones(size(1:length(ui)))'*(mean(dump(ui,phasei)+j*dump(ui,phaseq)));
   zphase_h = (dump(hi,phasei)+j*dump(hi,phaseq))-ones(size(1:length(hi)))'*(mean(dump(hi,phasei)+j*dump(hi,phaseq)));
   zphase_v = (dump(vi,phasei)+j*dump(vi,phaseq))-ones(size(1:length(hi)))'*(mean(dump(vi,phasei)+j*dump(vi,phaseq)));

    clear dump phasei phaseq

if 1
    hc = sqrt(zlin_h).*zphase_h./abs(zphase_h);
    vc = sqrt(zlin_v).*zphase_v./abs(zphase_v);
    uc = sqrt(zlin_u).*zphase_u./abs(zphase_u);

   clear zphase_h zphase_v zphase_u zlin_h zlin_v

    hc = hc-ones(size(1:length(hi)))'*mean(hc);
    vc = vc-ones(size(1:length(vi)))'*mean(vc);
    uc = uc-ones(size(1:length(ui)))'*mean(uc);
else
    hc = zphase_h;
    vc = zphase_v;
    uc = zphase_u;

   clear zphase_h zphase_v zphase_u zlin_h zlin_v
end


if 0
   if n<32769
       unit=ones(size(1:gates));
       ang_u=(180/pi)*atan2(imag(zphase_u),real(zphase_u));
       ang_h=(180/pi)*atan2(imag(zphase_h),real(zphase_h));
       ang_v=(180/pi)*atan2(imag(zphase_v),real(zphase_v));
       std_u=std(ang_u);
   end
end

%   ang_mod=zeros(size(uc));
%   ang_mod(2:2:n-4,:)=ones((n-4)/2,length(rangei)).*35.*pi./180;
%   uc=uc.*exp(j.*ang_mod);
%   clear ang_mod

%   index=zeros(size(uc));

   clear hi vi ui

