if [0]

	raster=2;
	scan=1;

	% 6197 UTLS/DCFZ case 3: 16 Jan 1999 0334-0515
	filen='/home/mm0800/chapmand/data/radar/6193dop'; 
	filenz='/home/mm0800/chapmand/data/radar/6193new'; 
	sumfile=[filen '.sum'];
	fname=[filen '.dat'];
	fnamez=[filenz '.dat'];
	
	dfilen='data.mat';
	cscdir='/home/mm0800/chapmand/matlab/vad/';
	filename=fname;
	
	extract
	
	cd /home/mm0800/chapmand/matlab/vad
	load([cscdir 'data.mat'])
	
	[mm nn]=size(v2');

	v2=v2(:,1:mm-3);
	azim=azim(1:mm-3);
	[mm nn]=size(v2');
	
	angles=azim(1:mm)'-90;
	Y=range'*cos(angles'*pi/180);
	X=range'*sin(angles'*pi/180);
	X=X.';
	Y=Y.';
	
	% Taken from ppiplot........
	danplot_vars
	
	maxvar=4;lonely1=3;lonely2=0; %for zapping program
	vu=v2;
	vmin=-15; %defaults - may be changed by unfolding routine...
	vmax=15;
	%unfold and zap
	disp('Unfolding...')
	[vu region]=munfill(v2);
	disp('...and zapping...');
	vu=mzap(vu,maxvar,lonely1,lonely2);
	index=find(isnan(vu)==0);
	vu=vu-30.0*floor(mean(mean(vu(index)+15))/30.0);
	%vu2=mzap(vu,4,3,0);
	%vmin=min(min(vu2));
	%vmax=max(max(vu2));
	
	figure(40); pcolor(azim,range,vu);shading flat ; colorbar ; zoom on
	
end

%===============Main VAD bit==================
C=0.67; %for lateral variations (kennedy75)
%C=0.5;  %for longitudinal variations (kennedy75)

z=1;
clear pi;

h=range.*sin(mean(elev)*pi/180);

index=min(find(h >= z));
range(index)

%set up variables for calculating the averagedspectrum
power_av=[];
count=0;
param2=[1e-3 -5/3]; % Initial conditions [epsilon power]
param1=[0 0 0 0 0];
outer_k=1e-3;
% Now fit to the first 3 harmonics:

global az sig C

for ind=1:10;

%index=index+2

sig=vu(index,:);
i=find(~isnan(sig));
az=azim(i);
sig=sig(i);

opts=foptions;opts(14)=4000;
param1=fmins('vadfun',param1,opts);
y=param1(1) + param1(2)*cos(az*pi/180) + param1(3)*sin(az*pi/180) + ...
	param1(4)*sin(2*az*pi/180) + param1(5)*sin(2*az*pi/180);
figure(ind)
clf
drawnow
set(gcf,'position',[50+ind*25, 530, 560, 420]);
plot(az,sig,'b'); hold on
plot(az,y,'r')
title(['Range = ' num2str(range(index))]);
drawnow
res0=y-sig;

s=2*((mean(diff(az))<0)-.5);
res=interp1([az+s*360 az az-s*360],[res0 res0 res0],azim);
% Now we have the residual, res, on the same 1D grid as azim

rest=fft(res);
n=length(rest);
rest(1)=[];
dl=abs(range(index)*1000.0*sin(mean(diff(azim)).*pi/180));
nyquist=(1/dl)/2;
k= ((1:n/2)/(n/2))*nyquist;
%power=(abs(rest(1:n/2)).^2)./k;
% see page 72 of Doviak and Zrnic
	S=(rest(1:n/2)).*conj(rest(1:n/2))*dl/length(res);
	power=S;
if length(power_av)>0
	power_av=power_av+power;
else
	power_av=power;
end
count=count+1;

if [0]

	%fit a power law to to small end of the spectrum
	
	global k power istart C
	istart=max(find(k <= outer_k));
	
	%epsilon=10e-3;
	
	opts=foptions;opts(14)=4000;
	param2=fmins('powerfun',param2,opts);
	epsilon=param2(1);
	pow=param2(2);
	
	klaw=k(istart:end);
	powerlaw=C*(epsilon^(2/3))*(klaw.^(pow));
end

figure(ind+20)
clf
drawnow
set(gcf,'position',[50+ind*25, 30, 560, 420]);
loglog(k,power), grid on
xlabel('k (cycles m^{-1})');ylabel('Power (m^3s^{-2})');
hold on
if [0]
	plot(klaw,powerlaw,'r');
	title([' Best fit for Power Law = ' num2str(pow)])
end
drawnow


index=index+1;

end

% Now we've finished doing the individual spectra....
% Time to do the average

power_av=power_av./count;

figure(50);

power=power_av;
clf
loglog(k,k.*power), grid on
xlabel('k (cycles m^{-1})');ylabel('Averaged k \times Power (m^2s^{-2})');

%fit a power law to to small end of the spectrum

global k power istart
istart=max(find(k <= outer_k));

%epsilon=10e-3;

opts=foptions;opts(14)=4000;
param2=fmins('powerfun',param2,opts);
epsilon=param2(1);
pow=param2(2);

klaw=k(istart:end);
powerlaw=C*(epsilon^(2/3))*(klaw.^(pow));
hold on
plot(klaw,klaw.*powerlaw,'r');

%Now do best fit with just -5/3 law
opts=foptions;
epsilon=1e-3;
epsilon=fmins('powerfun2',epsilon,opts);

klaw=k(istart:end);
powerlaw=C*(epsilon^(2/3))*(klaw.^(-5/3));
hold on
plot(klaw,klaw.*powerlaw,'k');

title(['Averaged \epsilon (-5/3 law, black line) = ' num2str(epsilon*1000) ...
			 ' \times 10^{-3} m^2 s^{-3}. Best fit power law= ' num2str(pow)])








